/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using SimpleJSON;using System.Collections.Generic;using MVR.FileManagementSecure;using System;using System.Linq;using GPUTools.Cloth.Scripts;using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;using MeshVR;namespace PluginIdea.DecalSystem{public class ClothSetter : MVRScript{private Material startMaterial;private ClothSettings clothSettings;private bool isExternalResourcesLoaded;private Renderer renderer;private Dictionary<string, Shader> dic_BundleShaders = new Dictionary<string, Shader>();private Request request;private bool IsExternalResourcesLoaded;private Material clothMat;public override void Init(){Utils.InitUI(CreateUIElement);clothSettings = containingAtom.reParentObject.GetComponentInChildren<ClothSettings>();renderer = clothSettings.GetComponent<Renderer>();startMaterial = new Material(renderer.material);UIInit();ResourceInit();}private void UIInit(){}private void ResourceInit(){string assetsBundlePath = Utils.GetPluginPath(this) + string.Format("/resources/dynamicdecal{0}.assetbundle", Utils.version);Request request = new Request{path = assetsBundlePath, callback = OnAssetBundleLoaded};AssetLoader.QueueLoadAssetBundleFromFile(request);}private void OnAssetBundleLoaded(Request request){this.request = request;Shader[] shaders = request.assetBundle.LoadAllAssets<Shader>();for (int i = 0;i < shaders.Length;i++){if (!dic_BundleShaders.ContainsKey(shaders[i].name)){string key = shaders[i].name;dic_BundleShaders.Add(key, shaders[i]);}}IsExternalResourcesLoaded = true;DelayInit();}int skipFrameCount1;private void LateUpdate(){if (skipFrameCount1 > 60){skipFrameCount1 = 0;if (clothMat != null){clothMat.SetBuffer("verts", clothSettings.Runtime.ClothVertices.ComputeBuffer);clothSettings.BroadcastMessage("OnApplicationFocus", true);}}skipFrameCount1++;}private void DelayInit(){List<Material> ms = renderer.materials.ToList();clothMat = new Material(dic_BundleShaders["PluginIdea/Cloth"]);ms.Add(clothMat);renderer.materials = ms.ToArray();}private void OnDestroy(){renderer.materials = new Material[1];renderer.material = startMaterial;Utils.DestroyUI();}}}