/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using SimpleJSON;using System.Collections.Generic;using MVR.FileManagementSecure;using System;using System.Linq;using GPUTools.Cloth.Scripts;using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;using MeshVR;namespace PluginIdea.DecalSystem{public class TransparentObjectSetter : MVRScript{private Atom containAtom;private List<Renderer> renderers;private Dictionary<string, Shader> dic_BundleShaders = new Dictionary<string, Shader>();private Request request;private bool IsExternalResourcesLoaded;public override void Init(){containAtom = containingAtom;ResourceInit();}private void ResourceInit(){string assetsBundlePath = Utils.GetPluginPath(this) + string.Format("/resources/dynamicdecal{0}.assetbundle", Utils.version);Request request = new Request{path = assetsBundlePath, callback = OnAssetBundleLoaded};AssetLoader.QueueLoadAssetBundleFromFile(request);}private void OnAssetBundleLoaded(Request request){this.request = request;Shader[] shaders = request.assetBundle.LoadAllAssets<Shader>();for (int i = 0;i < shaders.Length;i++){Debug.Log("Shader: " + shaders[i].name);if (!dic_BundleShaders.ContainsKey(shaders[i].name)){string key = shaders[i].name;dic_BundleShaders.Add(key, shaders[i]);}}IsExternalResourcesLoaded = true;DelayInit();}private void DelayInit(){FlagMesh(true);}private int beginLayer;private void FlagMesh(bool isActive){Transform rescaleTrans = containAtom.reParentObject.Find("object/rescaleObject");renderers = rescaleTrans.GetComponentsInChildren<Renderer>().ToList();if (renderers.Count > 0){renderers.ForEach(rd =>{List<Material> ms = rd.materials.ToList();if (isActive){rd.gameObject.layer = LayerMask.NameToLayer("Default");var clothMat = new Material(dic_BundleShaders["PluginIdea/General"]);ms.Add(clothMat);}else{if (ms.Count > 1){ms.RemoveAt(ms.Count - 1);}}rd.materials = ms.ToArray();});}}private void OnDestroy(){FlagMesh(false);}}}