/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using SimpleJSON;using System.Collections.Generic;using MVR.FileManagementSecure;using System;using System.Linq;using GPUTools.Cloth.Scripts;using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;using MeshVR;namespace PluginIdea.DecalSystem{public class PersonClothSetter : MVRScript{private Material startMaterial;private ClothSettings clothSettings;private DAZMesh dazmesh;private DAZSkinWrap wrap;private bool isExternalResourcesLoaded;private GameObject meshObject;private Dictionary<string, Shader> dic_BundleShaders = new Dictionary<string, Shader>();private Request request;private bool IsExternalResourcesLoaded;private Material clothMat;private DAZClothingItem tempClothItem;public override void Init(){Utils.InitUI(CreateUIElement);UIInit();ResourceInit();}private void UIInit(){}private void ResourceInit(){string assetsBundlePath = Utils.GetPluginPath(this) + string.Format("/resources/dynamicdecal{0}.assetbundle", Utils.version);Request request = new Request{path = assetsBundlePath, callback = OnAssetBundleLoaded};AssetLoader.QueueLoadAssetBundleFromFile(request);}private void OnAssetBundleLoaded(Request request){this.request = request;Shader[] shaders = request.assetBundle.LoadAllAssets<Shader>();for (int i = 0;i < shaders.Length;i++){if (!dic_BundleShaders.ContainsKey(shaders[i].name)){string key = shaders[i].name;dic_BundleShaders.Add(key, shaders[i]);}}IsExternalResourcesLoaded = true;DelayInit();}int skipFrameCount1;private DAZCharacterSelector dazcharacterSelector;private List<DAZClothingItem> activedClothingItems;private int clothItemIndex;private void DelayInit(){JSONStorable storableByID = containingAtom.GetStorableByID("geometry");dazcharacterSelector = storableByID as DAZCharacterSelector;activedClothingItems = dazcharacterSelector.clothingItems.Where(x => x.active == true).ToList();clothItemIndex = 0;tempClothItem = activedClothingItems[clothItemIndex];Utils.SetLayer(tempClothItem.transform, LayerMask.NameToLayer("UI"));dazmesh = tempClothItem.GetComponentInChildren<DAZMesh>();wrap = tempClothItem.GetComponentInChildren<DAZSkinWrap>();clothSettings = tempClothItem.GetComponentInChildren<ClothSettings>();meshObject = new GameObject("MeshObject");Utils.SetLayer(meshObject.transform, LayerMask.NameToLayer("UI"));meshObject.transform.SetParent(wrap.transform);meshObject.transform.localPosition = Vector3.zero;Utils.GetSafeComponent<MeshFilter>(meshObject).mesh = wrap.Mesh;Renderer rd = Utils.GetSafeComponent<MeshRenderer>(meshObject);rd.material = new Material(dic_BundleShaders["PluginIdea/Cloth2"]);}private void OnDestroy(){Destroy(meshObject);Utils.DestroyUI();}}}